#!/bin/bash

#####################################################################
# $Id: zarafa-safe-start.sh,v 1.2 2014/07/16 10:05:40 rusjako Exp $
#####################################################################
# Written and maintained by:
#    Stefan Jakobs <stefan.jakobs at tik.uni-stuttgart.de>
#
# Please send all comments, suggestions, bug reports,
#    etc, to mail-support at tik.uni-stuttgart.de
#####################################################################
# Copyright (c) 2013 Stefan Jakobs
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
#
#####################################################################

# Beschreibung


#### Set Environment ####
PATH="$PATH:/usr/bin/:/usr/sbin/:/bin:/sbin"

### Set Variables

debug=${debug:-0}
status=0

#### Functions ####

check_start_service() {
  local status=0
  local serv="$1"
  serv_status1="$(service $serv status)"
  if [ $? -ne 0 ] || [[ $serv_status1 =~ 'stop' ]]; then
     if [ $debug -ne '0' ]; then
        echo "${HOSTNAME}: $(date "+%d.%m.%Y %k:%M:%S status check: $serv_status1")"
     fi
     serv_status2="$(service $serv start)"
     retval="$?"
     if [ $debug -ne '0' ]; then
        echo "${HOSTNAME}: $(date "+%d.%m.%Y %k:%M:%S ${serv_status2}")"
     fi
     if [ $retval -ne 0 ]; then
        status=1
     else
        status=0
     fi
  else
     if [ $debug -ne 0 ]; then
        echo "${HOSTNAME}: $(date "+%d.%m.%Y %k:%M:%S status check: $serv_status1")"
     fi
     status=0
  fi
  return $status
}

#### MAIN ####

for serv in mysql /etc/init.d/zarafa-* puppet ; do
   if ! check_start_service ${serv##*/} ; then
      echo "ERROR: ${HOSTNAME}: failed to start $serv daemon!"
      exit 1
   fi
done

#### End of MAIN ####
